export interface IServerSearchData {
    filters: Record<string, string>;
    dates: IDateSpan;
    limit?: number;
    relationships: string;
    search?: string;
    sorts?: string;
    page?: number;
}
interface IServerSearchOptions {
    manual?: boolean;
    mainDateField?: string;
}
interface IDateSpan {
    startDate: Date | null;
    endDate?: Date | null;
}
interface ISearchState {
    filters: Record<string, string | null>;
    dates: IDateSpan;
    sorts: string;
    limit: number;
    relationships: string;
    search?: string;
    page?: number;
}
export interface InertiaRouterType {
    get: (url: string, data: Partial<Record<string, any>> | undefined, config: Partial<Record<string, any>>) => void;
}
export type UrlChangeCallback = (urlParams: string, UpdateSearch?: (params: string) => void) => Promise<void>;
export declare const filterParams: (mainDateField: string, externalFilters: Record<string, string | null>, dates: IDateSpan) => string;
export declare const getGroupParams: (groupValue: string) => string;
export declare const getRelationshipsParams: (relationships: string) => string;
export declare const getPaginationParams: (state: ISearchState) => string | 0 | undefined;
export declare const parseParams: (state: ISearchState) => string;
export declare const useServerSearch: (serverSearchData: Ref<Partial<IServerSearchData>>, options?: IServerSearchOptions, onUrlChange?: UrlChangeCallback, router?: InertiaRouterType) => {
    state: any;
    hasFilters: any;
    executeSearch: (delay?: number) => void;
    updateSearch: (urlParams: string) => any;
    changeSize: (limit: number) => void;
    paginate: (page: number) => void;
    reset: () => void;
    executeSearchWithDelay: (delay?: number) => void;
};
export {};
